package jp.hishidama.ant.taskdefs;

import java.io.*;
import java.util.*;

import jp.hishidama.ant.types.htlex.HtLexerConverter;
import jp.hishidama.html.lexer.rule.HtLexer;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.DirectoryScanner;
import org.apache.tools.ant.Task;
import org.apache.tools.ant.types.FileSet;

/**
 * HtHtmlLexer^XN.
 *<p>
 * {@link HtLexer}gpAHTMLt@ČEus^XNB
 * </p>
 *
 * @author <a target="hishidama" href=
 *         "http://www.ne.jp/asahi/hishidama/home/tech/soft/java/ant/htlex.html"
 *         >Ђ</a>
 * @since 2009.01.18
 * @version 2009.02.08
 */
public class HtLexerTask extends Task {

	protected File destDir;

	/**
	 * ufBNg[ݒ.
	 * <p>
	 * usꍇ̒ufBNg[Bw肵Ȃꍇ͓ǂݍ񂾃t@Cɏ㏑B
	 * </p>
	 *
	 * @param dir
	 *            fBNg[
	 */
	public void setTodir(File dir) {
		destDir = dir;
	}

	protected File backupDir;

	/**
	 * obNAbvfBNg[ݒ.
	 * <p>
	 * usꍇ̒uÕt@CobNAbvĂfBNg[B
	 * </p>
	 *
	 * @param dir
	 *            fBNg[
	 * @since 2009.02.08
	 */
	public void setBackupDir(File dir) {
		backupDir = dir;
	}

	protected List<FileSet> fileset = new ArrayList<FileSet>();

	/**
	 * filesetǉ.
	 *
	 * @param set
	 *            t@CZbgvf
	 */
	public void addFileset(FileSet set) {
		fileset.add(set);
	}

	protected HtLexerConverter converter;

	/**
	 * Ro[^[ݒ.
	 *
	 * @param converter
	 *            Ro[^[vf
	 * @throws BuildException
	 */
	public void addConfigured(HtLexerConverter converter) {
		this.converter = converter;
	}

	/**
	 * ^XNs.
	 */
	public void execute() throws BuildException {

		if (converter == null) {
			converter = new HtLexerConverter();
		}
		converter.validate();

		for (int i = 0; i < fileset.size(); i++) {
			FileSet fs = (FileSet) fileset.get(i);

			DirectoryScanner ds = fs.getDirectoryScanner(getProject());
			String[] names = ds.getIncludedFiles();
			for (int j = 0; j < names.length; j++) {
				File f = new File(ds.getBasedir(), names[j]);
				File wf = null;
				if (destDir != null) {
					wf = new File(destDir, names[j]);
				}
				File bf = null;
				if (backupDir != null) {
					bf = new File(backupDir, names[j]);
				}

				converter.execute(f, wf, bf);
			}
		}
	}
}
