package jp.hishidama.ant.types.htlex;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.taskdefs.condition.Condition;

import jp.hishidama.html.lexer.token.AttributeToken;

/**
 * HtHtmlLexer^O^Cv.
 *<p>
 * HTMLt@C̃^Ȏ̏fsf[^^CvB
 * </p>
 *
 * @author <a target="hishidama" href=
 *         "http://www.ne.jp/asahi/hishidama/home/tech/soft/java/ant/htlex.html"
 *         >Ђ</a>
 * @since 2009.01.21
 */
public class AttrCondType extends AttrType implements Condition {

	protected TagType tag;

	/**
	 * s.
	 *
	 * @param tag
	 *            ^O^Cv
	 * @throws BuildException
	 *             G[
	 */
	public void validate(TagType tag) throws BuildException {
		this.tag = tag;

		if (nameMatch == null && valueMatch == null && let == null
				&& quote == null) {
			throw new BuildException("attribute must be set.", getLocation());
		}
	}

	/**
	 * fs.
	 *
	 * @return w肳ĂɃ}b`ꍇAtrue
	 */
	@Override
	public boolean eval() {
		for (AttributeToken a : tag.getTokenList()) {
			if (matches(a)) {
				return true;
			}
		}
		return false;
	}
}
