package jp.hishidama.ant.types.htlex;

import jp.hishidama.html.lexer.token.AttributeToken;
import jp.hishidama.html.lexer.token.ValueToken;

import org.apache.tools.ant.types.DataType;

/**
 * HtHtmlLexer^O^Cv.
 *<p>
 * HTMLt@C̃^Ȏ̃}b`ێf[^^CvB
 * </p>
 *
 * @author <a target="hishidama" href=
 *         "http://www.ne.jp/asahi/hishidama/home/tech/soft/java/ant/htlex.html"
 *         >Ђ</a>
 * @since 2009.01.20
 */
public class AttrType extends DataType {

	protected MatchEnum nameMatch;

	/**
	 * Oݒ.
	 *
	 * @param name
	 *            
	 */
	public void setName(String name) {
		if (nameMatch == null) {
			nameMatch = new MatchEnum(MatchEnum.IGNORE_CASE);
		}
		nameMatch.setPattern(name);
	}

	/**
	 * O}b`O@ݒ.
	 *
	 * @param match
	 *            }b`O@
	 */
	public void setNameMatch(MatchEnum match) {
		if (nameMatch != null) {
			match.setPattern(nameMatch.getPatternString());
		}
		nameMatch = match;
	}

	protected String let;

	/**
	 * Lݒ.
	 *
	 * @param s
	 *            L
	 */
	public void setLet(String s) {
		let = s;
	}

	protected MatchEnum valueMatch;

	/**
	 * lݒ.
	 *
	 * @param value
	 *            l
	 */
	public void setValue(String value) {
		if (valueMatch == null) {
			valueMatch = new MatchEnum(MatchEnum.IGNORE_CASE);
		}
		valueMatch.setPattern(value);
	}

	/**
	 * l}b`O@ݒ.
	 *
	 * @param match
	 *            }b`O@
	 */
	public void setValueMatch(MatchEnum match) {
		if (valueMatch != null) {
			match.setPattern(valueMatch.getPatternString());
		}
		valueMatch = match;
	}

	protected String quote;

	/**
	 * NH[e[Vݒ.
	 *
	 * @param s
	 *            NH[e[V
	 */
	public void setQuote(String s) {
		quote = s;
	}

	/**
	 * }b`Of.
	 *
	 * @param a
	 *            
	 * @return w肳ĂɃ}b`ꍇAtrue
	 */
	public boolean matches(AttributeToken a) {
		String name = a.getName();
		if (!equalsName(name)) {
			return false;
		}

		if (!equalsLet(a.getLet())) {
			return false;
		}

		ValueToken vt = a.getValueToken();
		String v = (vt == null) ? null : vt.getValue();
		if (!equalsValue(v)) {
			return false;
		}
		String q1 = null, q2 = null;
		if (vt != null) {
			q1 = vt.getQuote1();
			q2 = vt.getQuote2();
		}
		if (!equalsQuote(q1) || !equalsQuote(q2)) {
			return false;
		}

		return true;
	}

	protected boolean equalsName(String s) {
		if (nameMatch == null) {
			return true;
		}
		return nameMatch.matches(s);
	}

	protected boolean equalsLet(String s) {
		if (let == null) {
			return true;
		}
		if (let.isEmpty() && s == null) {
			return true;
		}
		return let.equals(s);
	}

	protected boolean equalsValue(String s) {
		if (valueMatch == null) {
			return true;
		}
		return valueMatch.matches(s);
	}

	protected boolean equalsQuote(String q) {
		if (quote == null) {
			return true;
		}
		if (quote.isEmpty() && q == null) {
			return true;
		}
		return quote.equals(q);
	}
}
