package jp.hishidama.ant.types.htlex;

import java.io.*;
import java.nio.charset.Charset;
import java.util.*;

import org.apache.tools.ant.*;
import org.apache.tools.ant.types.*;
import org.apache.tools.ant.util.FileUtils;

import jp.hishidama.html.lexer.rule.HtLexer;
import jp.hishidama.html.lexer.token.*;
import jp.hishidama.html.parser.elem.*;
import jp.hishidama.html.parser.rule.HtParser;
import jp.hishidama.html.parser.rule.HtParserManager;

/**
 * HtHtmlLexerRo[^[.
 *<p>
 * {@link HtLexer}gpAHTMLt@ČEusf[^^CvB
 * </p>
 *
 * @author <a target="hishidama" href=
 *         "http://www.ne.jp/asahi/hishidama/home/tech/soft/java/ant/htlex.html"
 *         >Ђ</a>
 * @since 2009.01.18
 * @version 2009.02.21
 */
public class HtLexerConverter extends DataType {

	protected Charset encoding, outputEncoding;

	/**
	 * ̓t@CR[hݒ.
	 * <p>
	 * ݒ肳ȂꍇJavaVMftHg̕R[hƂȂB
	 * </p>
	 *
	 * @param encoding
	 *            R[h
	 */
	public void setEncoding(String encoding) {
		this.encoding = Charset.forName(encoding);
	}

	/**
	 * o̓t@CR[hݒ.
	 * <p>
	 * ݒ肳Ȃꍇ͓̓t@CƓR[hƂȂB
	 * </p>
	 *
	 * @param encoding
	 *            R[h
	 */
	public void setOutputEncoding(String encoding) {
		this.outputEncoding = Charset.forName(encoding);
	}

	protected boolean force, nowrite;

	/**
	 * o͎w.
	 *
	 * @param b
	 *            truȅꍇAύXĂt@Co͂B
	 */
	public void setForce(boolean b) {
		force = b;
	}

	/**
	 * o͎w.
	 *
	 * @param b
	 *            truȅꍇAύXĂt@Co͂ȂB
	 * @since 2009.02.08
	 */
	public void setNoWrite(boolean b) {
		nowrite = b;
	}

	protected int LogReadFileLevel = -1;
	protected int logMatchLevel = -1;
	protected int logUnmatchLevel = -1;
	protected int logWriteFileLevel = -1;
	protected int logConvertLevel = -1;

	/**
	 * Oo͐ݒiǍt@Cj.
	 * <p>
	 * ̐ݒƁAǂݍ񂾃t@COo͂B
	 * </p>
	 *
	 * @param level
	 *            Ox
	 */
	public void setLogReadFile(LogLevel level) {
		LogReadFileLevel = level.getLevel();
	}

	/**
	 * Oo͐ݒi}b`j.
	 * <p>
	 * ̐ݒƁAɃ}b`ꍇɃ}b`OeOo͂B
	 * </p>
	 *
	 * @param level
	 *            Ox
	 */
	public void setLogMatch(LogLevel level) {
		logMatchLevel = level.getLevel();
	}

	/**
	 * Oo͐ݒiA}b`j.
	 * <p>
	 * ̐ݒƁA1}b`ȂꍇɃt@COo͂B
	 * </p>
	 *
	 * @param level
	 *            Ox
	 */
	public void setLogUnmatch(LogLevel level) {
		logUnmatchLevel = level.getLevel();
	}

	/**
	 * Oo͐ݒiuj.
	 * <p>
	 * ̐ݒƁAusꍇɒueOo͂B
	 * </p>
	 *
	 * @param level
	 *            Ox
	 */
	public void setLogConvert(LogLevel level) {
		logConvertLevel = level.getLevel();
	}

	/**
	 * Oo͐ݒio̓t@Cj.
	 * <p>
	 * ̐ݒƁAt@Co͂t@COo͂B
	 * </p>
	 *
	 * @param level
	 *            Ox
	 */
	public void setLogWriteFile(LogLevel level) {
		logWriteFileLevel = level.getLevel();
	}

	protected boolean useParser = false;

	/**
	 * HtHtmlParsergpLݒ.
	 *<p>
	 * HtHtmlParserɂ\͌ʂgpIvVʓrw肵Ăꍇ́AtrueƂȂB
	 * </p>
	 *
	 * @param b
	 *            HtHtmlParsergpꍇAtrue
	 * @since 2009.02.17
	 */
	public void setUseParser(boolean b) {
		useParser = b;
	}

	protected int dumpParseNotFixLevel = -1;

	/**
	 * fobO_vim^Ojݒ.
	 * <p>
	 * HtHtmlParserɂ\͂Ŗm̃^O炻o͂B
	 * </p>
	 *
	 * @param level
	 *            Ox
	 * @since 2009.02.15
	 */
	public void setDumpParseNotFix(LogLevel level) {
		dumpParseNotFixLevel = level.getLevel();
		setUseParser(true);
	}

	protected final List<TagType> tagList = new ArrayList<TagType>();

	/**
	 * ^Oǉ.
	 *
	 * @param tag
	 *            ^O^Cv
	 */
	public void addConfigured(TagType tag) {
		tagList.add(tag);
	}

	protected final List<TextType> textList = new ArrayList<TextType>();

	/**
	 * eLXgǉ.
	 *
	 * @param text
	 *            eLXg^Cv
	 */
	public void addConfigured(TextType text) {
		textList.add(text);
	}

	/**
	 * s.
	 *
	 * @throws BuildException
	 *             G[
	 */
	public void validate() throws BuildException {
		for (TagType i : tagList) {
			i.validate(this);
		}
		for (TextType i : textList) {
			i.validate(this);
		}
	}

	protected File rf, wf;

	/**
	 * OóiǍt@Cj.
	 *
	 * @param msg
	 *            bZ[W
	 * @param level
	 *            Ox
	 */
	public void logReadFile(String msg, int level) {
		if (level >= 0) {
			log(msg + rf.getAbsolutePath(), level);
		}
	}

	private boolean matched;

	/**
	 * Oói}b`j.
	 *
	 * @param token
	 *            g[N
	 */
	public void logMatch(Token token) {
		if (logMatchLevel >= 0) {
			if (!matched) {
				logReadFile("match: ", logMatchLevel);
			}
			log(token.getLine() + "\t" + token.getText(), logMatchLevel);
		}
		matched = true;
	}

	/**
	 * OóiA}b`j.
	 */
	public void logUnmatch() {
		if (logUnmatchLevel >= 0) {
			logReadFile("unmatch: ", logUnmatchLevel);
		}
	}

	private boolean convert;

	/**
	 * Oóiuj.
	 *
	 * @param msg
	 *            bZ[W
	 * @param line
	 *            sԍ
	 * @param token
	 *            g[N
	 */
	public void logConvert(String msg, int line, Token token) {
		if (logConvertLevel >= 0) {
			if (!convert) {
				logReadFile("conv: ", logConvertLevel);
			}

			StringBuilder sb = new StringBuilder(32);
			sb.append(msg);
			sb.append(": ");
			sb.append(line);
			sb.append("\t");
			sb.append(token.getText());
			log(sb.toString(), logConvertLevel);
		}
		convert = true;
	}

	private boolean writeFile;

	/**
	 * Oóio̓t@Cj.
	 *
	 * @param f
	 *            t@C
	 */
	public void logWriteFile(File f) {
		if (logWriteFileLevel >= 0) {
			if (!writeFile) {
				log("write: " + f.getAbsolutePath(), logWriteFileLevel);
			}
		}
		writeFile = true;
	}

	protected HtLexer lexer = createLexer();

	protected HtLexer createLexer() {
		return new HtLexer();
	}

	/**
	 * w肳ꂽpHtLexerԂB
	 *<p>
	 * CX^XLĂׁAdgp͕sB
	 * </p>
	 *
	 * @param s
	 *            ߑΏ
	 * @return HtLexer
	 */
	public HtLexer getLexer(String s) {
		lexer.setTarget(s);
		return lexer;
	}

	/**
	 * {.
	 *<p>
	 * HTMLt@Cǂݍ݁A񌟍usB
	 * </p>
	 *
	 * @param rf
	 *            Ǎt@C
	 * @param wf
	 *            o̓t@C
	 * @param bf
	 *            obNAbvpt@C
	 * @throws BuildException
	 */
	public void execute(File rf, File wf, File bf) throws BuildException {
		this.rf = rf;
		this.wf = wf;
		this.matched = false;
		this.convert = false;
		this.writeFile = false;

		Reader r = createReader();

		ListToken tlist = createToken(r);
		HtListElement elist = createElement(tlist);

		boolean changed = (elist != null) ? convert(elist) : convert(tlist);
		if (!matched) {
			logUnmatch();
		}
		if (changed || force) {
			if (bf != null) {
				backup(rf, bf);
			}
			Writer w = createWriter();
			if (w != null) {
				try {
					if (elist != null) {
						elist.writeTo(w);
					} else {
						tlist.writeTo(w);
					}
				} catch (IOException e) {
					throw new BuildException(e, getLocation());
				} finally {
					try {
						w.close();
					} catch (IOException e) {
					}
				}
			}
		}
	}

	protected ListToken createToken(Reader r) {
		ListToken tlist;
		try {
			lexer.setTarget(r);
			tlist = lexer.parse();
		} catch (IOException e) {
			throw new BuildException(e, getLocation());
		} finally {
			try {
				lexer.close();
			} catch (IOException e) {
			}
		}
		tlist.calcLine(1);

		return tlist;
	}

	protected HtListElement createElement(ListToken tlist) {
		HtListElement elist = null;
		if (useParser) {
			HtParser parser = new HtParserManager().getDefaultParser();
			elist = parser.parse(tlist);
		}
		return elist;
	}

	/**
	 * Ώۃt@C擾.
	 *
	 * @return Ǎt@C
	 */
	public File getReadFile() {
		return rf;
	}

	protected FileUtils fu;

	protected void backup(File rf, File bf) {
		if (nowrite) {
			return;
		}
		if (fu == null) {
			fu = FileUtils.getFileUtils();
		}

		File parent = bf.getParentFile();
		if (!parent.exists()) {
			parent.mkdirs();
		}

		try {
			fu.copyFile(rf, bf, null, true, true);
		} catch (IOException e) {
			throw new BuildException(e, getLocation());
		}
	}

	protected Reader createReader() {
		logReadFile("read: ", LogReadFileLevel);
		try {
			if (encoding == null) {
				return new FileReader(rf);
			} else {
				return new InputStreamReader(new FileInputStream(rf), encoding);
			}
		} catch (RuntimeException e) {
			throw e;
		} catch (Exception e) {
			throw new BuildException(e, getLocation());
		}
	}

	protected Writer createWriter() {
		File f = (wf != null) ? wf : rf;
		logWriteFile(f);
		if (nowrite) {
			return null;
		}

		File parent = f.getParentFile();
		if (!parent.exists()) {
			parent.mkdirs();
		}

		Charset cs = outputEncoding;
		if (cs == null) {
			cs = encoding;
		}

		try {
			if (cs == null) {
				return new FileWriter(f);
			} else {
				return new OutputStreamWriter(new FileOutputStream(f), cs);
			}
		} catch (IOException e) {
			throw new BuildException(e, getLocation());
		}
	}

	/**
	 * HTMLύX.
	 * <p>
	 * {@link jp.hishidama.ant.taskdefs.HtLexerTask}ɂHTMLǂݍ܂ꂽɌĂ΂B<br>
	 * iHtHtmlParserɂč\͂ĂȂꍇɓ\bhĂ΂j<br>
	 * ̓eύXtrueԂƁA̓et@Cɏo͂B
	 * </p>
	 * <p>
	 * Ǝ̕ϊsꍇ́A\bhI[o[ChHTML̕ϊWbNB
	 * </p>
	 *
	 * @param tlist
	 *            ǂݍ܂ꂽHTML
	 * @return tlist̓eύXꍇAtrue
	 * @see #setUseParser(boolean)
	 */
	public boolean convert(ListToken tlist) {
		boolean ret = false;
		for (Token t : tlist) {
			ret |= convertToken(t, null);
		}
		return ret;
	}

	/**
	 * HTMLύX.
	 * <p>
	 * {@link jp.hishidama.ant.taskdefs.HtLexerTask}ɂHTMLǂݍ܂ꂽɌĂ΂B<br>
	 * iHtHtmlParserɂč\͂ꂽꍇɓ\bhĂ΂j<br>
	 * ̓eύXtrueԂƁA̓et@Cɏo͂B
	 * </p>
	 * <p>
	 * Ǝ̕ϊsꍇ́A\bhI[o[ChHTML̕ϊWbNB
	 * </p>
	 *
	 * @param elist
	 *            \͂ꂽHTML
	 * @return elist̓eύXꍇAtrue
	 * @see #setUseParser(boolean)
	 * @since 2009.02.17
	 */
	public boolean convert(HtListElement elist) {
		boolean ret = false;

		ret |= convertLoop(elist);

		dumpParseNotFix(elist);
		return ret;
	}

	protected boolean convertLoop(HtElement he) {
		if (he instanceof HtTokenElement) {
			HtTokenElement te = (HtTokenElement) he;
			Token t = te.getToken();
			if (t != null) {
				return convertToken(t, he);
			} else {
				return false;
			}
		}

		boolean ret = false;

		HtTagElement te = null;
		if (he instanceof HtTagElement) {
			te = (HtTagElement) he;
			Tag stag = te.getStartTag();
			if (stag != null) {
				ret |= convertTag(stag, he);
			}
		}

		HtListElement elist = (HtListElement) he;
		for (int i = 0; i < elist.size(); i++) {
			HtElement e = elist.get(i);
			if (e != null) {
				ret |= convertLoop(e);
			}
		}

		if (te != null) {
			Tag etag = te.getEndTag();
			if (etag != null) {
				ret |= convertTag(etag, he);
			}
		}

		return ret;
	}

	private StringPrintStream sps = null;

	protected StringPrintStream initPrintStream() {
		if (sps == null) {
			sps = new StringPrintStream();
		}
		sps.clear();
		return sps;
	}

	protected void dumpParseNotFix(HtListElement elist) {
		if (dumpParseNotFixLevel >= 0) {
			StringPrintStream ps = initPrintStream();
			HtElementUtil.dumpNotFix(elist, ps);
			if (!ps.isEmpty()) {
				logReadFile("notFix: ", dumpParseNotFixLevel);
				String s = ps.toString();
				log(s, dumpParseNotFixLevel);
			}
		}
	}

	protected boolean convertToken(Token t, HtElement he) {
		if (t instanceof Tag) {
			Tag tag = (Tag) t;
			return convertTag(tag, he);
		} else if (t instanceof TextToken) {
			TextToken text = (TextToken) t;
			return convertText(text, he);
		}
		return false;
	}

	/**
	 * ^Oϊ.
	 *
	 * @param tag
	 *            ^O
	 * @param he
	 *            ^ȎĂvfi͂ĂȂꍇAnullj
	 * @return eύXꍇAtrue
	 */
	public boolean convertTag(Tag tag, HtElement he) {
		boolean ret = false;

		for (TagType i : tagList) {
			ret |= i.convert(tag, he);
		}

		return ret;
	}

	/**
	 * eLXgϊ.
	 *
	 * @param text
	 *            eLXg
	 * @param he
	 *            eLXg̑Ăvfi͂ĂȂꍇAnullj
	 * @return eύXꍇAtrue
	 */
	public boolean convertText(TextToken text, HtElement he) {
		boolean ret = false;

		for (TextType i : textList) {
			ret |= i.convert(text, he);
		}

		return ret;
	}

	/**
	 * r.
	 *
	 * @param s1
	 *            
	 * @param s2
	 *            
	 * @return 񂪓ꍇAtrueinull͋󕶎ƂĔrj
	 */
	public boolean equals(String s1, String s2) {
		if (s1 == null || s1.isEmpty()) {
			if (s2 == null || s2.isEmpty()) {
				return true;
			}
			return false;
		} else {
			return s1.equals(s2);
		}
	}
}
