/**
 *
 */
package jp.hishidama.ant.types.htlex;

import jp.hishidama.html.lexer.token.Tag;
import jp.hishidama.html.parser.elem.HtElement;
import jp.hishidama.html.parser.elem.HtTagElement;

import org.apache.tools.ant.types.EnumeratedAttribute;

/**
 * ^OyANX.
 *<p>
 * ^ÕyA𔻒肷NXB
 * </p>
 *
 * @author <a target="hishidama" href=
 *         "http://www.ne.jp/asahi/hishidama/home/tech/soft/java/ant/htlex.html"
 *         >Ђ</a>
 * @since 2009.02.17
 */
public class PairTagEnum extends EnumeratedAttribute {
	/**
	 * ignoreFyA𔻒肵ȂiftHgj
	 */
	public static final String IGNORE = "ignore";
	protected static final int IGNORE_INDEX = 0;
	/**
	 * stagFJn^Oi&lt;tag&gt;j̏ꍇA^
	 */
	public static final String STAG = "stag";
	protected static final int STAG_INDEX = IGNORE_INDEX + 1;
	/**
	 * etagFI^Oi&lt;/tag&gt;j̏ꍇA^
	 */
	public static final String ETAG = "etag";
	protected static final int ETAG_INDEX = STAG_INDEX + 1;
	/**
	 * setagFJnI^Oi&lt;tag/&gt;j̏ꍇA^
	 */
	public static final String SETAG = "setag";
	protected static final int SETAG_INDEX = ETAG_INDEX + 1;
	/**
	 * startFvf̊Jni&lt;tag&gt;&lt;tag/&gt;j̏ꍇA^
	 */
	public static final String START = "start";
	protected static final int START_INDEX = SETAG_INDEX + 1;
	/**
	 * endFvf̏Ii&lt;/tag&gt;&lt;tag/&gt;j̏ꍇA^
	 */
	public static final String END = "end";
	protected static final int END_INDEX = START_INDEX + 1;
	/**
	 * pairFyAꍇA^
	 */
	public static final String PAIR = "pair";
	protected static final int PAIR_INDEX = END_INDEX + 1;
	/**
	 * nopairFyAꍇA^
	 */
	public static final String NO_PAIR = "nopair";
	protected static final int NOPAIR_INDEX = PAIR_INDEX + 1;

	@Override
	public String[] getValues() {
		return new String[] { IGNORE, STAG, ETAG, SETAG, START, END, PAIR,
				NO_PAIR };
	}

	public PairTagEnum() {
	}

	public PairTagEnum(String s) {
		setValue(s);
	}

	/**
	 * HtHtmlParsergpCfbNX̍Œl
	 */
	public static final int PARSER_INDEX = PAIR_INDEX;

	/**
	 * ^ÕyA.
	 *
	 * @param tag
	 *            ^O
	 * @param he
	 *            vfiHtHtmlParsergpĔ肷ꍇ͕K{j
	 * @return ɈvꍇAtrue
	 */
	public boolean matches(Tag tag, HtElement he) {
		switch (getIndex()) {
		default:
			return true;
		case STAG_INDEX:
			return "<".equals(tag.getTag1()) && ">".equals(tag.getTag2());
		case ETAG_INDEX:
			return "</".equals(tag.getTag1()) && ">".equals(tag.getTag2());
		case SETAG_INDEX:
			return "<".equals(tag.getTag1()) && "/>".equals(tag.getTag2());
		case START_INDEX:
			return "<".equals(tag.getTag1());
		case END_INDEX:
			return "</".equals(tag.getTag1()) || "/>".equals(tag.getTag2());
		case PAIR_INDEX:
		case NOPAIR_INDEX:
			boolean ret;
			if ("/>".equals(tag.getTag2())) {
				ret = true;
			} else if (he instanceof HtTagElement) {
				HtTagElement te = (HtTagElement) he;
				ret = (te.getStartTag() != null) && (te.getEndTag() != null);
			} else {
				ret = false;
			}
			if (getIndex() == NOPAIR_INDEX) {
				ret = !ret;
			}
			return ret;
		}
	}
}