package jp.hishidama.ant.types.htlex;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Location;
import org.apache.tools.ant.types.EnumeratedAttribute;

/**
 * uNX.
 *<p>
 * ̒usNXB
 * </p>
 *
 * @author <a target="hishidama" href=
 *         "http://www.ne.jp/asahi/hishidama/home/tech/soft/java/ant/htlex.html"
 *         >Ђ</a>
 * @since 2009.01.30
 * @version 2009.02.01
 */
public class StringOpeEnum extends EnumeratedAttribute {

	/**
	 * {@value}FPiuj
	 */
	public static final String LET = "let";
	/**
	 * {@value}F擪̂ݒu
	 *
	 * @see Matcher#replaceFirst(String)
	 */
	public static final String REP_FIRST = "replaceFirst";
	/**
	 * {@value}FSu
	 *
	 * @see Matcher#replaceAll(String)
	 */
	public static final String REP_ALL = "replaceAll";

	@Override
	public String[] getValues() {
		return new String[] { LET, REP_FIRST, REP_ALL };
	}

	public StringOpeEnum() {
	}

	public StringOpeEnum(String s) {
		setValue(s);
	}

	protected Pattern p;

	/**
	 * s.
	 *
	 * @param me
	 *            }b`O@
	 * @param loc
	 *            f[^^Cvʒu
	 * @throws BuildException
	 *             G[
	 */
	public void validate(MatchEnum me, Location loc) throws BuildException {
		switch (getIndex()) {
		case 1:// replaceFirst
		case 2:// replaceAll
			if (me == null || (p = me.getPattern()) == null) {
				throw new BuildException("match-pattern must be set.", loc);
			}
			break;
		}
	}

	/**
	 * ϊs.
	 *
	 * @param s
	 *            ϊ
	 * @param n
	 *            ϊ敶
	 * @return ϊ㕶
	 */
	public String convert(String s, String n) {
		int i = getIndex();
		switch (i) {
		case 1:
		case 2:
			if (s == null) {
				s = "";
			}
			if (n == null) {
				n = "";
			}
			break;
		}
		switch (i) {
		default: // let
			return n;
		case 1: // replaceFirst
			return p.matcher(s).replaceFirst(n);
		case 2: // replaceAll
			return p.matcher(s).replaceAll(n);
		}
	}
}
