package jp.hishidama.html.lexer.token;

import java.util.ArrayList;
import java.util.List;

/**
 * HtHtmlLexerg[Ni^Oj.
 *<p>
 * ^Oi{@literal <tag`></tag>}jێg[NB
 * </p>
 *
 * @author <a target="hishidama" href=
 *         "http://www.ne.jp/asahi/hishidama/home/tech/soft/java/htlexer.html"
 *         >Ђ</a>
 * @since 2009.01.10
 */
public class Tag extends NamedMarkup {

	/**
	 * @since 2009.02.07
	 */
	@Override
	public Tag clone() throws CloneNotSupportedException {
		return new Tag(this);
	}

	protected Tag(Tag o) {
		super(o);
	}

	protected static enum Pos {
		TAGO, NAME,
		// ATTR,
		// TAGC,
	}

	/**
	 * RXgN^[.
	 */
	public Tag() {
	}

	/**
	 * ǉ.
	 *
	 * @param attr
	 *            
	 */
	public void addAttribute(AttributeToken attr) {
		addBeforeTagC(attr);
	}

	/**
	 * Jn^Of.
	 *
	 * @return Jn^OiTAGOu&lt;vĵƂAtrue
	 */
	public boolean isStart() {
		return "<".equals(getTag1());
	}

	/**
	 * I^Of.
	 *
	 * @return I^OiTAGOu&lt;/v܂ TAGCu/&gt;vĵƂAtrue
	 */
	public boolean isEnd() {
		return "</".equals(getTag1()) || "/>".equals(getTag2());
	}

	/**
	 * ꗗ擾.
	 *
	 * @return ꗗiKnullȊOj
	 */
	public List<AttributeToken> getAttributeList() {
		List<AttributeToken> ret = new ArrayList<AttributeToken>(list.size());
		for (Token token : list) {
			if (token instanceof AttributeToken) {
				ret.add((AttributeToken) token);
			}
		}
		return ret;
	}

	/**
	 * 擾.
	 *
	 * @param name
	 *            i啶͖j
	 * @return i݂ȂꍇAnullj
	 */
	public AttributeToken getAttribute(String name) {
		for (int i = list.size() - 1; i >= 0; i--) {
			Token token = list.get(i);
			if (token instanceof AttributeToken) {
				AttributeToken a = (AttributeToken) token;
				if (name.equalsIgnoreCase(a.getName())) {
					return a;
				}
			}
		}
		return null;
	}

	/**
	 * l擾.
	 *
	 * @param name
	 *            i啶͖j
	 * @return li݂ȂꍇAnullj
	 */
	public String getAttributeValue(String name) {
		AttributeToken attr = getAttribute(name);
		if (attr != null) {
			return attr.getValue();
		}
		return null;
	}
}
