package jp.hishidama.html.parser.elem;

import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import jp.hishidama.html.lexer.token.ListToken;
import jp.hishidama.html.lexer.token.Tag;
import jp.hishidama.html.lexer.token.Token;

/**
 * vfXg.
 *<p>
 * HtHtmlParserɂAvf̃XgB
 * </p>
 *
 * @author <a target="hishidama" href=
 *         "http://www.ne.jp/asahi/hishidama/home/tech/soft/java/htlexer.html"
 *         >Ђ</a>
 * @since 2009.02.09
 * @version 2009.02.21
 */
public class HtListElement extends HtElement implements Iterable<HtElement> {

	@Override
	public Tag getStartTag() {
		return null;
	}

	@Override
	public Tag getEndTag() {
		return null;
	}

	protected List<HtElement> list;

	protected class ElemList extends ArrayList<HtElement> {

		private static final long serialVersionUID = 1L;

		@Override
		public boolean add(HtElement element) {
			element.setParent(HtListElement.this);
			return super.add(element);
		}

		@Override
		public void add(int index, HtElement element) {
			element.setParent(HtListElement.this);
			super.add(index, element);
		}

		@Override
		public HtElement set(int index, HtElement element) {
			element.setParent(HtListElement.this);
			return super.set(index, element);
		}
	}

	/**
	 * vfǉ.
	 *
	 * @param he
	 *            vf
	 */
	public void add(HtElement he) {
		if (list == null) {
			list = new ElemList();
		}
		list.add(he);
	}

	/**
	 * vfǉ.
	 *
	 * @param n
	 *            CfbNX
	 * @param he
	 *            vf
	 * @since 2009.02.21
	 */
	public void add(int n, HtElement he) {
		if (list == null) {
			list = new ElemList();
		}
		list.add(n, he);
	}

	/**
	 * vfXgݒ.
	 *
	 * @param elist
	 *            vf̃Xg
	 */
	public void setList(List<HtElement> elist) {
		this.list = elist;
		for (HtElement e : elist) {
			e.setParent(this);
		}
	}

	/**
	 * vfXg擾.
	 *
	 * @return vf̃Xg
	 */
	public List<HtElement> getList() {
		return list;
	}

	/**
	 * vfXg̃Ce[^[擾.
	 */
	@Override
	public Iterator<HtElement> iterator() {
		if (list == null) {
			return Collections.<HtElement> emptyList().iterator();
		}
		return list.iterator();
	}

	/**
	 * vf擾.
	 *
	 * @return ێĂvf̌
	 */
	public int size() {
		if (list == null) {
			return 0;
		}
		return list.size();
	}

	/**
	 * vf擾.
	 *
	 * @param i
	 *            CfbNX
	 * @return vfiꍇnullj
	 */
	public HtElement get(int i) {
		if (list == null) {
			return null;
		}
		if (i < 0 || i >= list.size()) {
			return null;
		}
		return list.get(i);
	}

	/**
	 * vfʒu擾.
	 *
	 * @param he
	 *            vf
	 * @return vf̈ʒuiꍇ-1j
	 * @since 2009.02.21
	 */
	public int indexOf(HtElement he) {
		if (list == null) {
			return -1;
		}
		return list.indexOf(he);
	}

	/**
	 * vf폜.
	 *
	 * @param i
	 *            CfbNX
	 * @return 폜ꂽvfi폜Ȃꍇnullj
	 */
	public HtElement remove(int i) {
		if (list == null) {
			return null;
		}
		if (i < 0 || i >= list.size()) {
			return null;
		}
		return list.remove(i);
	}

	@Override
	public boolean isEmpty() {
		return (list == null) || list.isEmpty();
	}

	@Override
	public int getTextLength() {
		int len = 0;
		if (list != null) {
			for (HtElement e : list) {
				if (e != null) {
					len += e.getTextLength();
				}
			}
		}
		return len;
	}

	@Override
	public void writeTo(StringBuilder sb) {
		if (list != null) {
			for (HtElement e : list) {
				if (e != null) {
					e.writeTo(sb);
				}
			}
		}
	}

	@Override
	public void writeTo(Writer w) throws IOException {
		if (list != null) {
			for (HtElement e : list) {
				if (e != null) {
					e.writeTo(w);
				}
			}
		}
	}

	@Override
	public HtElement searchToken(Token t) {
		if (list != null) {
			for (HtElement e : list) {
				if (e != null) {
					HtElement r = e.searchToken(t);
					if (r != null) {
						return r;
					}
				}
			}
		}
		return null;
	}

	@Override
	public void toToken(ListToken tlist) {
		if (list != null) {
			for (HtElement e : list) {
				if (e != null) {
					e.toToken(tlist);
				}
			}
		}
	}
}
